/*	+-------------------------------------------------------------------------------------------------------------------------------+
	| Interface Compact Flash / PIC + FAT16 avec un PIC18F452																		|																							|
	+-------------------------------------------------------------------------------------------------------------------------------+
	| Copyright (C) 2005 Charles RINCHEVAL (charles.r@digitalspirit.org)															|
	+-------------------------------------------------------------------------------------------------------------------------------+
	| Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence Publique Gnrale GNU 	|
	| publie par la Free Software Foundation (version 2 ou bien toute autre version ultrieure choisie par vous).					|
	| Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,					|
	| y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.											|
	| Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.														|
	| Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme, si ce n'est pas le cas,	|
	| crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis. 					|
	+-------------------------------------------------------------------------------------------------------------------------------+

	Todo :
	- Rien !

 */


#include "cf.h"

#pragma udata CF_C_UDATA


/*	Tempo
 */
void cf_delay(void) {
	unsigned char c;
//	Delay1KTCYx(255);
	for (c = 0; c < 255; c++) {
		;
	}
}


/*	Configure les ports correctement
 */
void cf_init_host(void) {

	TRISA = CF_TRIS_A;			// Config des ports
	TRISE = CF_TRIS_E;
	TRISD = CF_TRIS_D_INPUT;

	CF_OE = 0;					// Config des broches ...
	CF_WE = 0;					// ... de contrle
	CF_CE1 = 1;
	CF_RESET = 1;

	CF_DATA_W = 0;				// Port de donnes

	CF_ADDR = 0;				// Port d'adresses

	CF_CE1 = 0;

	CF_CONTROL = CF_LAT_A;
}


/*	Renvoie si la carte est insre
 */
unsigned char cf_detect(void) {
//	if (!CF_CD1)
//		cf_reset();

//	while (cf_is_busy() && (!cf_is_ready())); // ###############

	return (!CF_CD1);
}


/*	Ecrit une commande
	@param reg Le registe  accder
	@param data La donne  crire
 */
void cf_write_reg(unsigned char reg, char data) {

	while (cf_is_busy() && (!cf_is_ready()));

	TRISD = CF_TRIS_D_OUTPUT;

	CF_ADDR = reg;
cf_delay();		// ############################
	while (!CF_READY);

	CF_DATA_W = data;
	while (!CF_READY);

	CF_WE = 0;
cf_delay();		// ############################
	CF_WE = 1;
cf_delay();		// ############################

	TRISD = CF_TRIS_D_INPUT;

	CF_ADDR = CF_REG_DATA;
}


/*	Lit un registre
	@param reg Le registe  accder
 */
unsigned char cf_read_reg(unsigned char reg) {

	unsigned char buf0;

	TRISD = CF_TRIS_D_OUTPUT;
	while (!CF_READY);

	CF_ADDR = reg;
	while (!CF_READY);
	TRISD = CF_TRIS_D_INPUT;

	CF_OE = 0;
cf_delay();		// ############################
	buf0 = CF_DATA_R;
	CF_OE = 1;

	return buf0;
}


/*	Ecrit un octet
	@param data
 */
void cf_write(char data) {

//	while (cf_is_busy() && (!cf_is_ready())); // ###############

	TRISD = CF_TRIS_D_OUTPUT;

	while (!CF_READY);

	CF_DATA_W = data;
	while (!CF_READY);

	CF_WE = 0;
	Nop();
	CF_WE = 1;

	TRISD = CF_TRIS_D_INPUT;
}


/*	Lecture 8bits
 */
unsigned char cf_read8() {

	unsigned char buf0;

	while (!CF_READY);

	TRISD = CF_TRIS_D_INPUT;

	CF_OE = 0;
	Nop();
	buf0 = CF_DATA_R;
	CF_OE = 1;

	return buf0;
}


/*	Lecture 16bits
 */
unsigned int cf_read16() {

	unsigned char buf0;
	unsigned char buf1;
	unsigned int buf2;

	while (!CF_READY);

	TRISD = CF_TRIS_D_INPUT;

	CF_OE = 0;
	Nop();
	buf0 = CF_DATA_R;
	CF_OE = 1;

	while (!CF_READY);

	CF_OE = 0;
	Nop();
	buf1 = CF_DATA_R;
	buf2 = ((int)buf1 << 8) | buf0;
	CF_OE = 1;

	return buf2;
}


/*	On test si la carte est valide
	@return Renvoie CF_OK si la signature est bonne, sinon CF_ERROR
 */
unsigned char cf_valid(void) {

	unsigned int buf;

	cf_write_reg(CF_REG_COMMAND, CF_CMD_IDENTIFY_DEVICE);
	CF_ADDR = 0;
	buf = cf_read16();

	return (buf == 0x848A) ? CF_STATUS_OK : CF_STATUS_ERROR;
}


/*	On tente d'identifier la carte
	@param sIDevice Pointeur sur une structure
	@return Renvoie CF_OK si la signature est bonne, sinon CF_ERROR
 */
unsigned char cf_identify(IdentifyDevice *sIDevice) {

	int i;
	unsigned short sbuf0;
	unsigned short sbuf1;

	unsigned char ret;

	cf_write_reg(CF_REG_COMMAND, CF_CMD_IDENTIFY_DEVICE);

	CF_ADDR = 0;

	sIDevice->genConfig = cf_read16();
	sIDevice->dNbrCylinders = cf_read16();
	cf_read16();
	sIDevice->dNbrHeads = cf_read16();
	cf_read16();
	cf_read16();
	sIDevice->dNbrSectorPerTrack = cf_read16();

	sbuf0 = cf_read16();
	sbuf1 = cf_read16();

	sIDevice->nbrSectorPerCard = ((long)sbuf1 << 16) | sbuf0;

	cf_read16();

	for (i = 0; i < 20; i++)
		sIDevice->serialNumber[i] = cf_read16();

	ret = (sIDevice->genConfig == 0x848A) ? CF_STATUS_OK : CF_STATUS_ERROR;
	
	return ret;
}


/*	Reset de la carte
 */
void cf_reset(void) {
	char toto;

//	CF_CE1 = 0;
/*
while (1) {
	PORTC = 0;
	Delay10TCYx(25);
	PORTC = 255;
	Delay10TCYx(25);
}
*/
//	while (1) {
//	while (cf_cmd_diagnostic() != 1) {

		CF_RESET = 1;
		Delay10TCYx(25);	//  1 durant plus de 25us
		CF_RESET = 0;
		Delay10TCYx(25);	//  1 durant plus de 25us

//	}
//	Delay1KTCYx(200);	//  0 durant plus de 2ms

//		if (CF_READY)
//			return;
//	}

//	while (CF_READY) {
//	}

//#define SET_REG(reg, value) (ide_write_register(reg ## _IDX, value))

	cf_write_reg(CF_REG_HEAD, 0b11100000);

	while (cf_is_busy()); // ###############

}


/*	Slectionne la carte
 */
void cf_enable(void) {
	CF_CE1 = 0;
	Nop();
	cf_reset();
	CF_OE = 1;
	Nop();
	CF_WE = 1;
}


/*	Excute la commande diagnostique
	@param Code erreur :
		* 0x01 : Pas d'erreur
		* 0x02 : Formatter device error
		* 0x03 : Sector buffer error
		* 0x04 : ECC circuitry error
		* 0x05 : Controlling uprocessor error
		* 0x8X : Slave error in the true IDE mode
 */
unsigned char cf_cmd_diagnostic(void) {
	DEBUGF("Diagnostique en cours !");
	cf_write_reg(CF_REG_COMMAND, CF_CMD_EXEC_DIAGNOSTIC);
	return cf_read_reg(CF_REG_ERROR);
}


/*	Skip un certain nombre d'octets
	@param count Le nombre d'octets  skipper
 */
void cf_skip8(unsigned char count) {
	for (count; count > 0; count--) {
		while (!CF_READY);
		CF_OE = 0;
cf_delay();		// ############################
		CF_OE = 1;
cf_delay();		// ############################
	}
}


/*	Lit le registre concern et renvoie si la CF est BUSY
 */
unsigned char cf_is_busy(void) {
	CF_ADDR = CF_REG_COMMAND;
	return ((cf_read8() & 0x80) == 0x80);
}


/*	Lit le registre concern et renvoie si la CF est READY
 */
unsigned char cf_is_ready(void) {
	CF_ADDR = CF_REG_COMMAND;
	return ((cf_read8() & 0x40) == 0x40);
}


/*	Renvoie 0 si la carte n'est pas prte
 */
unsigned char cf_check_ready(void) {
	return CF_READY;
}


/*	Positionne le pointeur !
	@param lba Adresse LBA
 */
void cf_set_position(unsigned long lba, unsigned char sector_cnt) {

	while ((cf_is_busy() & 0x80) == 0x80 && (cf_is_busy() & 0x40) == 0x40);

	lba = lba & 0x0FFFFFFF;
	lba = lba | 0xE0000000;

	cf_write_reg(CF_REG_HEAD, *(((char*)&lba) + 3));
	cf_write_reg(CF_REG_CYL_HI, *(((char*)&lba) + 2));
	cf_write_reg(CF_REG_CYL_LO, *(((char*)&lba) + 1));

	cf_write_reg(CF_REG_SEC_NUM, *(((char*)&lba) + 0));
	cf_write_reg(CF_REG_SEC_CNT, sector_cnt);
}



/*	+-----------------------------+
	| Manipulations sur le Buffer |
	+-----------------------------+
 */



#ifdef WRITE_ENABLED

/*	Charge le buffer  partir de l'adresse pointe
 */
void cf_buffer_load(void) {
	unsigned int i;

	cf_write_reg(CF_REG_COMMAND, CF_CMD_READ_SECTOR);

	for (i = 0; i < BK_BUFFER_SIZE; i++) {
		BK_Buffer[i] = cf_read8();
	}
}


/*	Ecrit le buffer dans l'adresse prcdemment pointe
	@param ulong sector Le secteur voulue
 */
void cf_buffer_flush(void) {
	unsigned int i;

	cf_write_reg(CF_REG_COMMAND, CF_CMD_WRITE_SECTOR);

	for (i = 0; i < BK_BUFFER_SIZE + 1; i++)
		cf_write(BK_Buffer[i]);
}

#endif
